package org.gvsig.fmap.dal.store.gpe;

import org.gvsig.fmap.dal.feature.FeatureType;
import org.gvsig.fmap.dal.feature.NewFeatureStoreParameters;
import org.gvsig.tools.ToolsLocator;
import org.gvsig.tools.dynobject.DelegatedDynObject;
import org.gvsig.tools.dynobject.DynClass;
import org.gvsig.tools.dynobject.DynStruct;
import org.gvsig.tools.observer.Observer;
import org.gvsig.tools.persistence.PersistenceManager;

public class GPENewStoreParameters extends GPEStoreParameters implements NewFeatureStoreParameters {

    public static final String DYNCLASS_NAME = "GPENewStoreParameters";

    private FeatureType defaultFeatureType;
    private long futureShapeCount = 0;
    private Observer observer;
	
    private DelegatedDynObject delegatedDynObject;

	protected static DynClass DYNCLASS = null;
	
	protected DelegatedDynObject getDelegatedDynObject() {
		
		return delegatedDynObject;
	}

		
	public static void registerPersistent() {
		 DynStruct definition =
			 ToolsLocator.getPersistenceManager().addDefinition(GPENewStoreParameters.class,
					 DYNCLASS_NAME,
					 "new GPE File Store parameters",
	                null,
	                null);
	      
		 	definition.extend(PersistenceManager.PERSISTENCE_NAMESPACE,GPEStoreParameters.PARAMETERS_DEFINITION_NAME);
	}	

    protected void initialize() {
		this.delegatedDynObject = (DelegatedDynObject) ToolsLocator
				.getDynObjectManager().createDynObject(DYNCLASS);
	}

	public long getFutureShapeCount() {
		return futureShapeCount;
	}

	public void setFutureShapeCount(long c) {
		futureShapeCount = c;
	}

    public FeatureType getDefaultFeatureType() {
        return this.defaultFeatureType;
    }

    public void setDefaultFeatureType(FeatureType dft) {
        defaultFeatureType = dft;
    }

	public void setObserver(Observer obs) {
		observer = obs;
	}
	
	public Observer getObserver() {
		return observer;
	}
}
