package org.gvsig.mobile.app;

import java.awt.Color;
import java.util.Hashtable;
import java.util.Vector;

import org.gvsig.fmap.crs.CRSFactory;
import org.gvsig.mobile.core.auxfunctions.ShowMessage;
import org.gvsig.mobile.core.auxfunctions.StringConstructor;
import org.gvsig.mobile.core.concepts.HelpTool;
import org.gvsig.mobile.core.constants.GvSigConstants;
import org.gvsig.mobile.core.exceptions.GvSigPropertyNotAttachedException;
import org.gvsig.mobile.core.extensions.interfaces.IFunctionality;
import org.gvsig.mobile.core.extensions.interfaces.IFunctionalityEnvelope;
import org.gvsig.mobile.core.extensions.interfaces.ITool;
import org.gvsig.mobile.core.extensions.interfaces.IToolEnvelope;
import org.gvsig.mobile.core.extensions.interfaces.IToolbar;
import org.gvsig.mobile.core.extensions.interfaces.IgvSIGMobileToolbar;
import org.gvsig.mobile.ui.awt.mapcontrol.MapControl;
import org.gvsig.mobile.ui.awt.mapcontrol.MapEventsThread;
import org.gvsig.mobile.ui.awt.statusbar.StatusBarManager;
import org.gvsig.mobile.ui.awt.tools.ToolBar;
import org.gvsig.mobile.ui.awt.tools.ToolBarButton;
import org.gvsig.mobile.ui.awt.tools.ToolBarGroup;
import org.osgi.framework.BundleContext;
import org.osgi.framework.BundleEvent;
import org.osgi.framework.BundleListener;
import org.osgi.framework.ServiceEvent;
import org.osgi.framework.ServiceRegistration;
import org.osgi.service.wireadmin.Consumer;
import org.osgi.service.wireadmin.Envelope;
import org.osgi.service.wireadmin.Wire;
import org.osgi.service.wireadmin.WireConstants;
import org.zaval.lw.LwComponent;
import org.zaval.lw.LwComposite;
import org.zaval.lw.LwPanel;
import org.zaval.lw.LwRasterLayout;
import org.zaval.lw.LwStatusBar;
import org.zaval.lw.event.LwMouseEvent;
import org.zaval.lw.event.LwMouseListener;
import org.zaval.lw.event.LwMouseMotionListener;


public class MainFrame extends LwPanel implements IgvSIGMobileToolbar,
		LwComposite, LwMouseListener, LwMouseMotionListener, Consumer, BundleListener {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	public BundleContext bc;
	protected MapControl map;

	// private MapControl map;
	private ToolBarGroup toolManager;
	public MapEventsThread met2;
	private ServiceRegistration reg;
	private Vector tools;
	
	private StatusBarManager statusBarManager;

	public void init(MapEventsThread met) {
		this.met2 = met;
		

//		setSize(640, 480);
		toolManager = new ToolBarGroup(this.bc);
		// ToolBarButton bar2 = new ToolBarButton("SAMPLE2",
		// "group_info_floating_filled", "Sample Toolbar 2", this.bc);
		// toolManager.addToolBarButton(bar2);
		// ToolBarButton bar1 = new ToolBarButton(new DefaultToolBar("SAMPLE",
		// "Sample Toolbar", "group_info_floating_filled", this.bc));
		// toolManager.addToolBarButton(bar1);

		// instantiate tools:
		/*
		 * AddCursorTool act = new AddCursorTool(map.getViewPort(), met,
		 * "mytool");
		 * 
		 * DrawLineTool dlt = new DrawLineTool( map.getViewPort(), Color.GREEN,
		 * 1, met, "linetool2");
		 * 
		 * ChangeColorTool cct = new ChangeColorTool(map, "colortool");
		 * ShowSettingsTools sst = new ShowSettingsTools(null);
		 * RectangleZoomTool rzt = new RectangleZoomTool(map.getViewPort(),
		 * "recttool", this.bc);
		 * 
		 * 
		 * 
		 * addTool(act); addTool(dlt); addTool(cct); addTool(rzt); addTool(sst);
		 */

		// toolManager = new ToolBarGroup();
		// Last control added is showed on top
		// It is different to AWT
		add(map);
		add(toolManager);
	}
	
	public void setStatusBarManager(StatusBarManager man) {
		statusBarManager = man;
		add(man.getStatusBar());
	}

	public MainFrame(String title, BundleContext cont) {
		this.bc = cont;
		setBackground(Color.RED);
		setLwLayout(new LwRasterLayout());
		// super(title, Application.RUNNING_ON_JME);
		if (map == null) {
			map = new MapControl();
			map.getViewPort().setProjection(CRSFactory.getCRS("EPSG:4326"));
			// map.getV
		}
		this.tools = new Vector();
		Hashtable props = new Hashtable();
		props.put(WireConstants.WIREADMIN_CONSUMER_FLAVORS, new Class[] {
				Envelope.class, ITool.class, IFunctionality.class});
		props.put(GvSigConstants.SERVICE_PID,
				GvSigConstants.GvSIGMobile_TOOLBAR_MANAGER);
		// props.put(WireConstants.WIREADMIN_CONSUMER_SCOPE,
		// Envelope.class.getName());

		reg = bc.registerService(Consumer.class.getName(), this, props);
		bc.addBundleListener(this);

	}

	public MapControl getMapControl() {
		
		return map;
	}

	public void recalc() {
		
		map.setSize(getWidth() - getInsets().left - getInsets().right,
				getHeight() - getInsets().top - getInsets().bottom);
		map.setLocation(getInsets().left, getInsets().top);
		toolManager.setLocation(getInsets().left, getInsets().top);

		// TODO: ALBERTO -> DEFINIR LA ALTURA DEL ROLLING TOOLBAR
		toolManager.setSize(getWidth() - getInsets().left - getInsets().right,
				getHeight() - getInsets().top - getInsets().bottom);
		
		
		// reposition status bar
		if (statusBarManager != null) {

			LwStatusBar b = statusBarManager.getStatusBar();
			if (b != null) {
				int cli_w = this.getSize().width - getInsets().left - getInsets().right;
				cli_w = Math.min(480, cli_w);
				int sbarheight = cli_w / 10;
				b.setSize(getWidth() - getInsets().left - getInsets().right, sbarheight);
				b.setLocation(getInsets().left, getHeight() - getInsets().bottom - sbarheight);
			}
		}
	}

	// We catch clicks in the toolbarbanager empty space and pass it to
	// mapcontrol
	public boolean catchInput(LwComponent arg0) {
		if (arg0 == toolManager)
			return true;
		if (arg0 instanceof ToolBar)
			return true;
		return false;
	}

	public void mouseClicked(LwMouseEvent arg0) {
		map.mouseClicked(arg0);
	}

	public void mouseEntered(LwMouseEvent arg0) {
		map.mouseEntered(arg0);
	}

	public void mouseExited(LwMouseEvent arg0) {
		map.mouseExited(arg0);

	}

	public void mousePressed(LwMouseEvent arg0) {
		map.mousePressed(arg0);
		
	}

	public void mouseReleased(LwMouseEvent arg0) {
		map.mouseReleased(arg0);

	}

	public void endDragged(LwMouseEvent arg0) {
		map.endDragged(arg0);

	}

	public void mouseDragged(LwMouseEvent arg0) {
		map.mouseDragged(arg0);
	}

	public void mouseMoved(LwMouseEvent arg0) {
		map.mouseMoved(arg0);

	}

	public void startDragged(LwMouseEvent arg0) {
		map.startDragged(arg0);

	}

	public Object getMET() {
		return met2;
	}

	public Object getViewPort() {
		// TODO Auto-generated method stub
		return map.getViewPort();
	}

	public void producersConnected(Wire[] wires) {
		if (wires != null) {
			ShowMessage.Show(StringConstructor.Construct(new String[] {
					"Connected to ", String.valueOf(wires.length), " wires" }),
					true);
		} else {
			ShowMessage.Show("Not connected to any wire", true);
		}
	}

	public void updated(Wire wire, Object value) {
		/*
		 * TODO: JOAN, NACHO, ISMA, JAVI--> NECESITAMOS UN M�TODO PARA SABER SI
		 * QUEREMOS QUITAR O PONER LA TOOL VIGILEM QUIN PATRO ADOPTEM VIGILEM
		 * COM DIGUEM LA ACCI� A PRENDRE AMB L'OBJECTE QUE VA DINS EL WIRE
		 */

		/*
		 * en vez de pasar el objeto que se registra, pasamos un Envelope con el
		 * objeto y el evento as� sabemos si hay que registrar, actualizar, etc.
		 * Para poder comunicarse, Consumer y Producer tienen que a�adir a la
		 * clave WireConstants.WIREADMIN_CONSUMER_FLAVORS el valor
		 * IToolEnvelope.class
		 */
		if (wire.getProperties().get(WireConstants.WIREADMIN_PRODUCER_PID) == GvSigConstants.EXTENSION_MANAGER_TOOLBAR) {
			if (value instanceof IToolEnvelope) {
				processTool((IToolEnvelope)value);
			} else if (value instanceof IFunctionalityEnvelope) {
				processFunctionality((IFunctionalityEnvelope)value);
			} else {
				return;
			}			
		}
	}
	
	private void processFunctionality(IFunctionalityEnvelope envelope) {

		IFunctionality f = envelope.getFunctionality();
		switch (envelope.getServiceEvent()) {
		case ServiceEvent.REGISTERED:
			try {
					resolveFunctionality(f);
				} catch (GvSigPropertyNotAttachedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			break;
		case ServiceEvent.MODIFIED:
			
			break;
		case ServiceEvent.UNREGISTERING:
			try {
					unresolveFunctionality(f);
				} catch (GvSigPropertyNotAttachedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			break;
		}
	}
	
	private void resolveFunctionality(IFunctionality f) throws GvSigPropertyNotAttachedException {
		if (tools == null) return;
		
		final int size = tools.size();
		
		ITool t;
		for(int i = 0; i<size; i++) {
			try {
				t = (ITool)tools.elementAt(i);
				
				if (!(t instanceof IToolbar)) {
					if (t.getFunctionalityID().compareTo(f.getID()) == 0) {
						t.setFuncSolved(f);						
					}
				}				
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
	}
	
	private void unresolveFunctionality(IFunctionality f) throws GvSigPropertyNotAttachedException {
		if (tools == null) return;
		
		final int size = tools.size();
		
		ITool t;
		for(int i = 0; i<size; i++) {
			t = (ITool)tools.elementAt(i);
			if (t.getFunctionalityID().compareTo(f.getID()) == 0) {
				t.setFuncSolved(null);
			}
		}
	}
	
	private void processTool(IToolEnvelope envelope) {		

		// si acabamos de a�adir un HelpTool no volvemos a a�adir el
		// componente
		ITool t = envelope.getTool();
		if (t instanceof HelpTool)
			return;

		switch (envelope.getServiceEvent()) {
		case ServiceEvent.REGISTERED:
			registerTool(t);
			break;
		case ServiceEvent.MODIFIED:
			modifyTool(t);
			break;
		case ServiceEvent.UNREGISTERING:
			unregisterTool(t);
			break;
		}
	}
	

	public void registerTool(Object tool) {
		if (!tools.contains((ITool) tool)) {
			if (tool instanceof IToolbar) {
				this.addToolbar((IToolbar) tool);
			} else if (tool instanceof ITool) {
				this.addTool((ITool) tool);
			} else {
				// TODO: Lanzar excepci�n
			}
		}
	}

	public void unregisterTool(Object tool) {
		// TODO: ALBERTO -> IToolbar extiende ITool por lo que si
		// comprobamos primero si es instancia de ITool siempre devuelve
		// TRUE
		// ver qu� propiedades comunes tienen ITool e IToolbar y definir
		// bien sus interfaces
		if (tool instanceof IToolbar) {
			this.removeToolbar((IToolbar) tool);
		} else if (tool instanceof ITool) {
			this.removeTool((ITool) tool);
		} else {
			// TODO: Lanzar excepci�n
		}
	}

	public void modifyTool(Object tool) {
		if (tool instanceof IToolbar) {
			this.updateToolbar((IToolbar) tool);
		} else if (tool instanceof ITool) {
			this.updateTool((ITool) tool);
		} else {
			// TODO: Lanzar excepci�n
		}
	}

	public void addTool(ITool tool) {
		toolManager.addTool(tool);
		this.tools.add(tool);
		repaint();
	}

	public void removeTool(ITool tool) {
		toolManager.removeTool(tool);
		this.tools.remove(tool);
		repaint();
	}

	public void updateTool(ITool tool) {
		int index = -1;

		try {
			index = getToolIndex(tool.getKey());
		} catch (GvSigPropertyNotAttachedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		if (index >= 0) {
			tools.set(index, tool);
		}
	}

	public void addToolbar(IToolbar toolbar) {
		toolManager.addToolBarButton(new ToolBarButton(toolbar));
		this.tools.add((ITool) toolbar);
		repaint();
	}

	public void removeToolbar(IToolbar toolbar) {
		try {			
			toolManager.removeToolBarButton(toolbar.getFunctionalityID());
			this.tools.remove((ITool) toolbar);
		} catch (GvSigPropertyNotAttachedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public void updateToolbar(IToolbar toolbar) {
		int index = -1;
		try {
			index = getToolIndex(toolbar.getKey());
		} catch (GvSigPropertyNotAttachedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		if (index >= 0) {
			tools.set(index, toolbar);
		}
	}

	public int getToolIndex(String key) {
		final int size = tools.size();
		Vector v = tools;

		for (int i = 0; i < size; i++) {
			try {
				if (((ITool) v.elementAt(i)).getKey().compareTo(key) == 0) {
					return i;
				}
			} catch (GvSigPropertyNotAttachedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		return -1;
	}

	public void bundleChanged(BundleEvent event) {
		// TODO Auto-generated method stub
	}
	
	public ITool getActiveExclusiveTool() {
		ITool tool = null;		
		
		try {
			tool = this.toolManager.getToolPool().getActiveExclusiveTool();
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			return tool;
		}
	}
}