package org.gvsig.mobile.core.auxfunctions;


import org.gvsig.mobile.core.exceptions.GvSigServiceNotFoundException;
import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceReference;
import org.osgi.service.wireadmin.WireAdmin;


public class OSGiMethods {
	
	private static WireAdmin w = null;

	/**
	 * 
	 * @param bc OSGi Bundle Context
	 * @return The WireAdmin Service
	 * @throws GvSigServiceNotFoundException If Wire Admin is not found 
	 */
	public static WireAdmin getWireAdmin(BundleContext bc) throws GvSigServiceNotFoundException{
		if (w == null) {
			ServiceReference sr = bc.getServiceReference(WireAdmin.class.getName());
			WireAdmin wa=null;
			if (sr != null) {
				wa = (WireAdmin) bc.getService(sr);
			} else {
				ShowMessage.Show("Service Reference of Wire Admin = NULL", true);
			}
			if(wa!=null){
				w = wa;
				return wa;
			}
			else{
				throw new GvSigServiceNotFoundException("Wire Admin");
			}
		} else {
			return w;
		}
		
	}
}
