package org.gvsig.mobile.core.concepts;


import java.util.Hashtable;

import org.gvsig.mobile.core.auxfunctions.FunctionalityResolutor;
import org.gvsig.mobile.core.auxfunctions.ShowMessage;
import org.gvsig.mobile.core.constants.GvSigConstants;
import org.gvsig.mobile.core.exceptions.GvSigPropertyNotAttachedException;
import org.gvsig.mobile.core.exceptions.GvSigServiceNotFoundException;
import org.gvsig.mobile.core.extensions.interfaces.IFunctionality;
import org.gvsig.mobile.core.extensions.interfaces.ITool;
import org.osgi.framework.BundleContext;

/**
 * The basic Tool, it broadcasts it's state and provides a constructor
 * 
 * @author jcarras
 *
 */
public class DefaultTool implements ITool{
	private Hashtable props = new Hashtable();
	
	private int position = 0;

	public BundleContext bc;
	public IFunctionality funcSolved;
	
	public DefaultTool(){
		this.setToolType(ITool.RUN_INMEDIATELY_TOOL);
	}
	
	public DefaultTool(String key, String shortDescription, 
			String toolBarKey, int toolType, String ico,BundleContext bc, int position){
		this.setKey(key);
		this.setShortDescription(shortDescription);
		this.setToolbarKey(toolBarKey);
		this.setToolType(toolType);
		this.setIcon(ico);
		this.setBundleContext(bc);
		this.setPosition(position);		
	}
	public DefaultTool(String key, String shortDescription, 
			String toolBarKey, int toolType, BundleContext bc, int position){
		this(key,shortDescription,toolBarKey,toolType,null,bc, position);
	}

	public String getKey() throws GvSigPropertyNotAttachedException {
		Object Value= this.props.get(GvSigConstants.TOOL_KEY);
		if(Value!=null){
			return Value.toString();
		}
		throw new GvSigPropertyNotAttachedException("Tool Key");
		
	}

	public void setKey(String key) {
		this.props.put(GvSigConstants.TOOL_KEY,key);
	}

	public String getShortDescription() throws GvSigPropertyNotAttachedException {
		Object Value=this.props.get(GvSigConstants.TOOL_SHORT_DESCRIPTION);
		if(Value!=null){
			return Value.toString();
		}
		throw new GvSigPropertyNotAttachedException("Tool short Description");
	}

	public void setShortDescription(String shortDescription) {
		this.props.put(GvSigConstants.TOOL_SHORT_DESCRIPTION, shortDescription);
	}

	public String getToolbarKey() throws GvSigPropertyNotAttachedException {
		Object Value=this.props.get(GvSigConstants.TOOLBAR_KEY);
		if(Value!=null){
			return Value.toString();
		}
		throw new GvSigPropertyNotAttachedException("Tool toolbar key");
	}

	public void setToolbarKey(String toolbarKey) {
		if(toolbarKey!=null){
		this.props.put(GvSigConstants.TOOLBAR_KEY, toolbarKey);
		}
		
	}

	public int getToolType() throws GvSigPropertyNotAttachedException {
		Object Value =this.props.get(GvSigConstants.TOOL_TYPE);
		if(Value!=null){			
			return Integer.parseInt(Value.toString());
		}
		throw new GvSigPropertyNotAttachedException("Tool type");
		
	}

	public void setToolType(int toolType) {
		this.props.put(GvSigConstants.TOOL_TYPE, new Integer(toolType));
	}

	public String getIcon() throws GvSigPropertyNotAttachedException {
		Object Value=this.props.get(GvSigConstants.TOOL_ICON);
		if(Value!=null){
			return Value.toString();
		}
		throw new GvSigPropertyNotAttachedException("Tool icon");
		
	}
	
	public void setIcon(String icon) {
		if(icon!=null){
		this.props.put(GvSigConstants.TOOL_ICON, icon);
		}
		
	}

	public String getAltText() throws GvSigPropertyNotAttachedException {
		Object Value=this.props.get(GvSigConstants.TOOL_ALT);
		if(Value!=null){
			return Value.toString();
		}
		throw new GvSigPropertyNotAttachedException("Tool Alt Text");
	}

	public void setAltText(String altText) {
		this.props.put(GvSigConstants.TOOL_ALT, altText);
	}

	public String getComments() throws GvSigPropertyNotAttachedException {
		Object Value=this.props.get(GvSigConstants.TOOL_COMMENTS);
		if(Value!=null){
			return Value.toString();
		}
		throw new GvSigPropertyNotAttachedException("Tool Comments");
	}

	public void setComments(String comments) {
		this.props.put(GvSigConstants.TOOL_COMMENTS, comments);
	}

	public String getExtensionID() throws GvSigPropertyNotAttachedException {
		Object Value=this.props.get(GvSigConstants.EXTENSION_ID);
		if(Value!=null){
			return Value.toString();
		}
		throw new GvSigPropertyNotAttachedException("Tool Extension ID");
	}

	public void setExtensionID(String extensionID) {
		this.props.put(GvSigConstants.EXTENSION_ID, extensionID);
	}

	public String getFunctionalityID() throws GvSigPropertyNotAttachedException {
		Object Value=this.props.get(GvSigConstants.FUNCTIONALITY_ID);
		if(Value!=null){
			return Value.toString();
		}
		throw new GvSigPropertyNotAttachedException("Tool Functionallity ID");
	}
	
	public void setFunctionalityID(String functionalityID) {
		this.props.put(GvSigConstants.FUNCTIONALITY_ID, functionalityID);
	}

	public String getFunctionalityName() throws GvSigPropertyNotAttachedException {
		Object Value=this.props.get(GvSigConstants.FUNCTIONALITY_NAME);
		if(Value!=null){
			return Value.toString();
		}
		throw new GvSigPropertyNotAttachedException("Tool functionallity name");
	}


	public void setFunctionalityName(String functionalityName) {
		this.props.put(GvSigConstants.FUNCTIONALITY_NAME, functionalityName);
	}

	public String getFunctionalityVersion() throws GvSigPropertyNotAttachedException {
		Object Value=this.props.get(GvSigConstants.FUNCTIONALITY_VERSION);
		if(Value!=null){
			return Value.toString();
		}
		throw new GvSigPropertyNotAttachedException("Tool functionallity version");
	}


	public void setFunctionalityVersion(String functionalityVersion) {
		this.props.put(GvSigConstants.FUNCTIONALITY_VERSION, functionalityVersion);
	}

	public String getFunctionalityProvider() throws GvSigPropertyNotAttachedException {
		Object Value=this.props.get(GvSigConstants.FUNCTIONALITY_PROVIDER);
		if(Value!=null){
			return Value.toString();
		}
		throw new GvSigPropertyNotAttachedException("Tool functionality provider");
	}


	public void setFunctionalityProvider(String functionalityProvider) {
		this.props.put(GvSigConstants.FUNCTIONALITY_PROVIDER, functionalityProvider);
	}

	public String getFunctionalityExtensionID() throws GvSigPropertyNotAttachedException {
		Object Value=this.props.get(GvSigConstants.FUNCTIONALITY_EXTENSION_ID);
		if(Value!=null){
			return Value.toString();
		}
		throw new GvSigPropertyNotAttachedException("Tool functionality extension ID");
	}


	public void setFunctionalityExtensionID(String functionalityExtensionID) {
		this.props.put(GvSigConstants.FUNCTIONALITY_EXTENSION_ID, functionalityExtensionID);
	}

	public String getFunctionalityInterfaceID() throws GvSigPropertyNotAttachedException {
		Object Value=this.props.get(GvSigConstants.FUNCTIONALITY_INTERFACE_ID);
		if(Value!=null){
			return Value.toString();
		}
		throw new GvSigPropertyNotAttachedException("Tool functionality interface ID");
	}


	public void setFunctionalityInterfaceID(String functionalityInterfaceID) {
		this.props.put(GvSigConstants.FUNCTIONALITY_INTERFACE_ID, functionalityInterfaceID);	
	}

	public String getFunctionalityInterfaceName() throws GvSigPropertyNotAttachedException {
		Object Value=this.props.get(GvSigConstants.FUNCTIONALITY_INTERFACE_NAME);
		if(Value!=null){
			return Value.toString();
		}
		throw new GvSigPropertyNotAttachedException("Tool Functionality interface name");
	}


	public void setFunctionalityInterfaceName(String functionalityInterfaceName) {
		this.props.put(GvSigConstants.FUNCTIONALITY_INTERFACE_NAME, functionalityInterfaceName);	
	}

	public String getFunctionalityInterfaceVersion() throws GvSigPropertyNotAttachedException {
		Object Value=this.props.get(GvSigConstants.FUNCTIONALITY_INTERFACE_VERSION);
		if(Value!=null){
			return Value.toString();
		}
		throw new GvSigPropertyNotAttachedException("Tool functionality interface version");
	}


	public void setFunctionalityInterfaceVersion(String functionalityInterfaceVersion) {
		this.props.put(GvSigConstants.FUNCTIONALITY_INTERFACE_VERSION, functionalityInterfaceVersion);	
	}


	public String getName() throws GvSigPropertyNotAttachedException {
		Object Value=this.props.get(GvSigConstants.TOOL_NAME);
		if(Value!=null){
			return Value.toString();
		}
		throw new GvSigPropertyNotAttachedException("Tool name");
	}


	public void setName(String name) {
		this.props.put(GvSigConstants.TOOL_NAME, name);	
	}

	public String getText() throws GvSigPropertyNotAttachedException {
		Object Value=this.props.get(GvSigConstants.TOOL_TEXT);
		if(Value!=null){
			return Value.toString();
		}
		throw new GvSigPropertyNotAttachedException("Tool text");
	}


	public void setText(String text) {
		this.props.put(GvSigConstants.TOOL_TEXT, text);
	}

	public Hashtable getProps() {
		return this.props;
	}
	
	private void getFunctionality(){
		
		String ID,name,version,eID,FIID,FIIN,FIIV;
		ID=name=version=eID=FIID=FIIN=FIIV="";
		
		try {
			ID=this.getFunctionalityID();
		} catch (GvSigPropertyNotAttachedException e) {
		} 
		try {
			name=this.getFunctionalityName();
		} catch (GvSigPropertyNotAttachedException e) {
		}
		try {
			version=this.getFunctionalityVersion();
		} catch (GvSigPropertyNotAttachedException e) {
		} 
		try {
			eID=this.getExtensionID();
		} catch (GvSigPropertyNotAttachedException e) {
		} 
		try {
			FIID=this.getFunctionalityInterfaceID();
		} catch (GvSigPropertyNotAttachedException e) {
		} 
		try {
			FIIN=this.getFunctionalityInterfaceName();
		} catch (GvSigPropertyNotAttachedException e) {
		} 
		try {
			FIIV=this.getFunctionalityInterfaceVersion();
		} catch (GvSigPropertyNotAttachedException e) {
		}
		
		try{
		IFunctionality myFunc=FunctionalityResolutor.solve(ID, name, version, eID, FIID, FIIN, FIIV, this.bc);
		setFuncSolved(myFunc);
		}
		catch(GvSigServiceNotFoundException ex){
			ShowMessage.Show(ex.toString());
		}		
	}
	
	public void setFuncSolved(IFunctionality funcSolved){		
		this.funcSolved=funcSolved;
	}
	
	public IFunctionality getFuncSolved(){
		if (funcSolved == null)
			getFunctionality();
		return this.funcSolved;
	}

	public BundleContext getBundleContext() {
		return this.bc;
	}

	public void setBundleContext(BundleContext bc) {
		this.bc=bc;
		
	}
	
	public void setProps(Hashtable props) {
		this.props = props;
	}

	public int getPosition() {
		return position;
	}
	
	public void setPosition(int position) {
		this.position = position;
	}
}
