package org.gvsig.mobile.core.constants;

/**
 * This interface contains the constants used to include values in the tables of properties and OSGi filters
 */
public interface GvSigConstants {

	//File type
	/**
	 * Constant used for determine a filetype
	 */
	public static final String FILETYPE_ID="FILETYPE-ID";
	
	/**
	 * Constant used for determine a functionality to process a filetype
	 */
	public static final String FILETYPE_FUNCID="FILETYPE-FUNCID";
	
	/**
	 * Constant used for determine a filetype description
	 */
	public static final String FILETYPE_DESC="FILETYPE-DESC";
	
	//Extension
	/**
	 * Constant used for determine the IDENTIFIER of an Extension
	 */
	public static final String EXTENSION_ID="EXTENSION-ID";
	
	/**
	 * Constant used for determine the NAME of an extension
	 */
	public static final String EXTENSION_NAME="EXTENSION-NAME";
	
	/**
	 * Constant used for determine the VERSION of an extension
	 */
	public static final String EXTENSION_VERSION="EXTENSION-VERSION";
	
	/**
	 * Constant used for determine the PROVIDER of an extension
	 */
	public static final String EXTENSION_PROVIDER="EXTENSION-PROVIDER";
	
	/**
	 * Constant used for determine the DATE OF PUBLICATION of an extension
	 */
	public static final String EXTENSION_PUBLICATIONDATE="EXTENSION-PUBLICATIONDATE";
	
	/**
	 * Constant used for determine the DESCRIPTION of an extension
	 */
	public static final String EXTENSION_DESCRIPTION="EXTENSION-DESCRIPTION";
	
	/**
	 * Constant used for determine the COMMENTS of an extension
	 */
	public static final String EXTENSION_COMMENTS="EXTENSION-COMMENTS";
	
	//Tool
	
	/**
	 * Constant used for determine the IDENTIFIER of a TOOL
	 */
	public static final String TOOL_KEY="TOOL-KEY";
	
	/**
	 * Constant used for determine the NAME of a TOOL
	 */
	public static final String TOOL_NAME="TOOL-NAME";
	
	/**
	 * Constant used for determine the TEXT of a TOOL
	 */
	public static final String TOOL_TEXT="TOOL-TEXT";
	
	/**
	 * Constant used for determine the PATH TO THE ICON of a TOOL
	 */
	public static final String TOOL_ICON="TOOL-ICON";
	
	//TODO: JOAN: TEXT-ALTTEXT??????
	public static final String TOOL_ALT="TOOL-ALT";
	
	/**
	 * Constant used for determine the DESCRIPTION of a TOOL
	 */
	public static final String TOOL_SHORT_DESCRIPTION="TOOL-SHORT-DESCRIPTION";
	
	/**
	 * Constant used for determine the COMMENTS of a TOOL
	 */
	public static final String TOOL_COMMENTS="TOOL-COMMENTS";

	
	/**
	 * Constant used for determine the TYPE of a TOOL</br>This value will determine the future behavior of the tool in relation to other.
	 */
	public static final String TOOL_TYPE="TOOL-TYPE";
	
	//ToolBar
	
	/**
	 * Constant used for determine the IDENTIFIER of a TOOLBAR
	 */
	public static final String TOOLBAR_KEY="TOOLBAR-KEY";
	
	/**
	 * Constant used for determine the ICON of a TOOLBAR
	 */
	public static final String TOOLBAR_ICON="TOOLBAR-ICON";
	
	/**
	 * Constant used for determine the NAME of a TOOLBAR
	 */
	public static final String TOOLBAR_NAME="TOOLBAR-NAME";

	//Functionality
	
	/**
	 * Constant used for determine the IDENTIFIER of a FUNCTIONALITY
	 */
	public static final String FUNCTIONALITY_ID="FUNCTIONALITY-ID";
	
	/**
	 * Constant used for determine the NAME of a FUNCTIONALITY
	 */
	public static final String FUNCTIONALITY_NAME="FUNCTIONALITY-NAME";
	
	/**
	 * Constant used for determine the VERSION of a FUNCTIONALITY
	 */
	public static final String FUNCTIONALITY_VERSION="FUNCTIONALITY-VERSION";
	
	/**
	 * Constant used for determine the PROVIDER of a FUNCTIONALITY
	 */
	public static final String FUNCTIONALITY_PROVIDER="FUNCTAIONLITY-PROVIDER";
	
	/**
	 * Constant used for determine the IDENTIFIER of the EXTENSION associated with a FUNCTIONALITY
	 */
	public static final String FUNCTIONALITY_EXTENSION_ID="FUNCTIONALITY-EXTENSION-ID";
	
	/**
	 * Constant used for determine the IDENTIFIER of the INTERFACE associated with a FUNCTIONALITY
	 */
	public static final String FUNCTIONALITY_INTERFACE_ID="FUNCTIONALITY-INTERFACE-ID";
	
	/**
	 * Constant used for determine the NAME of the INTERFACE associated with a FUNCTIONALITY
	 */
	public static final String FUNCTIONALITY_INTERFACE_NAME="FUNCTIONALITY-INTERFACE-NAME";
	
	/**
	 * Constant used for determine the VERSION of the INTERFACE associated with a FUNCTIONALITY
	 */
	public static final String FUNCTIONALITY_INTERFACE_VERSION="FUNCTIONALITY-INTERFACE-VERSION";
	
	/**
	 * Constant used for determine the DESCRIPTION of a FUNCTIONALITY
	 */
	public static final String FUNCTIONALITY_DESCRIPTION="FUNCTIONALITY-DESCRIPTION";
	
	/**
	 * Constant used for determine the COMMENTS of a FUNCTIONALITY
	 */
	public static final String FUNCTIONALITY_COMMENTS="FUNCTIONALITY-COMMENTS";

	
	/**
	 * Constant used for determine if a FUNCTIONALITY is subscribed to Mouse Events
	 */
	public static final String FUNCTIONALITY_LISTEN_TO_MOUSE_EVENTS="FUNCTIONALITY-LISTEN-TO-MOUSE-EVENTS";
	
	/**
	 * Constant used for determine the mouse events that have subscribed a FUNCTIONALITY
	 */
	public static final String FUNCTIONALITY_MOUSE_EVENTS_SUBSCRIBED="FUNCTIONALLITY-MOUSE-EVENTS-SUBSCRIBED";
	
	//WireConstants
	
	//TODO: JOAN, NACHO, ISMA--> Estes constants son per a determinar producers i consumers.
	
	/**
	 * Constant used for determine de Identifier of a service 
	 */
	public static final String SERVICE_PID="service.pid";
	
	
	/**
	 * Constant used for include in a wire the Mouse subscriptions of a FUNCTIONALITY
	 */
	public static final String MOUSE_SUBSCRIPTIONS="MOUSE-SUBSCRIPTIONS";
	
	/**
	 * Constant that is used for identify the ToolBar Extension Manager as a producer of a wire
	 */
	public static final String EXTENSION_MANAGER_TOOLBAR="es.gvsig.mobile.core.extensionmanager.toolbar";
	

	/**
	 * Constant that is used for identify the Menu Extension Manager as a producer of a wire
	 */
	public static final String EXTENSION_MANAGER_MENU="es.gvsig.mobile.core.extensionmanager.menu";
	
	/**
	 * Constant that is used for identify the GvSIG ToolBar Manager as a consumer of a wire
	 */
	public static final String GvSIGMobile_TOOLBAR_MANAGER="es.gvsig.mobile.core.implementation.gvsigmobiletoolbar";
	
	/**
	 * Constant that is used for identify the GvSIG Menu Manager as a consumer of a wire
	 */
	public static final String GvSIGMobile_MENU_MANAGER="es.gvsig.mobile.core.implementation.gvsigmobilemenu";
	
	/**
	 * Constant that is used for identify the GvSIG Mouse Event Provider as a producer of a wire
	 */
	public static final String GvSIGMobile_MOUSE_EVENT_PROVIDER="es.gvsig.mobile.core.implementation.igvsigmobilemouseeventprovider";
	
	

}
