package org.gvsig.mobile.core.extensions.interfaces;

import java.util.Hashtable;

import org.gvsig.mobile.core.exceptions.GvSigServiceNotFoundException;
import org.osgi.framework.BundleContext;

/**
 * Interface used to define file types as Data Sources. Only registered
 * file types can be loaded on a FileChooserDialog
 * @author aromeu
 *
 */
public interface IFileType {
	
	/**
	 * The File Type, i.e., the extension of an archive: ecw, shp, jpg, etc.
	 * @return
	 */
	public String getFileType();
	
	/**
	 * A description of the file type
	 * @return
	 */
	public String getFileTypeDescription();
	
	public void setFileType(String fileType);	
	
	public void setFileTypeDescription(String fileTypeDescription);
	
	public void setFunctionalityID(String funcID);
	
	public String getFunctionalityID();
	
	public IFileProviderFunctionality getFunctionality() throws GvSigServiceNotFoundException; 
	
	public Hashtable getProps();
	
	public BundleContext getBundleContext();

}
