/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2006 Prodevelop and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   http://www.gvsig.gva.es
 *
 *    or
 *
 *   Prodevelop Integracin de Tecnologas SL
 *   Conde Salvatierra de lava , 34-10
 *   46004 Valencia
 *   Spain
 *
 *   +34 963 510 612
 *   +34 963 510 968
 *   gis@prodevelop.es
 *   http://www.prodevelop.es
 *
 *    or
 *
 *   Instituto de Robtica
 *   Apartado de correos 2085
 *   46071 Valencia
 *   (Spain)
 *   
 *   +34 963 543 577
 *   jjordan@robotica.uv.es
 *   http://robotica.uv.es
 *   
 */

package org.gvsig.mobile.extension.base.forms.view;

import java.awt.AWTEvent;
import java.awt.Graphics;
import java.awt.event.FocusEvent;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;

import org.apache.log4j.Logger;
import org.gvsig.mobile.ui.awt.WindowManager;
import org.zaval.lw.event.LwKeyEvent;
import org.zaval.lw.event.LwKeyListener;
import org.zaval.lw.event.LwMouseEvent;
import org.zaval.lw.event.LwMouseListener;

import thinlet.Thinlet;



/**
 * This class contains the methods the thinlet template can 
 * call, currently btnSave and btnCancel 
 * @author jcarras
 *
 */
public class ThinletForm extends Thinlet implements LwKeyListener, LwMouseListener {
	
	public boolean cancelled=true;
	public boolean modified=false;
	// private Dialog parent;
	private static Logger logger = Logger.getLogger(ThinletForm.class);
	
	protected void processEvent(AWTEvent e) {
		
		// logger.debug(e.toString());
		
		if (e instanceof MouseEvent) {
			MouseEvent me = (MouseEvent)e;
			if (me.getID()== MouseEvent.MOUSE_PRESSED) {
				AWTEvent e1 = new FocusEvent(this,FocusEvent.FOCUS_GAINED); 
				super.processEvent(e1);
				AWTEvent e0 = new MouseEvent(this,MouseEvent.MOUSE_MOVED,0,0,
						me.getX(),
						me.getY(),
						0,false);
				super.processEvent(e0);
			}
			super.processEvent(me);
		} else {
			super.processEvent(e);
		}
		
	}
	
	public ThinletForm() {
		// parent=parent_;
		this.requestFocus();
	}
	
	public void btnCancel(){
		cancelled=true;
		modified=false;
		WindowManager.getInstance().closeActivePanel();
		this.destroy();
	}
	
	public boolean destroy() {
		return super.destroy();
	}
	
	
	public void btnSave(){
		cancelled=false;
		modified=true;
		WindowManager.getInstance().closeActivePanel();
	}	
	
	private void paint(Graphics g,
			int clipx, int clipy, int clipwidth, int clipheight,
			Object component, boolean enabled) {
		////System.out.println("repaint(" + clipx + ", " + clipy + ", " + clipwidth + ", " + clipheight + ")");
		super.paint(g);
	}
	
	public void paintAll(Graphics g){
		//System.out.println("paintAll(Graphics g)");
		super.paintAll(g);
	}
	public void paintComponents(Graphics g){
		//System.out.println("paintComponents(Graphics g) numcomponents= " + this.getComponents().length);
		super.paintComponents(g);
	}
	public void repaint(){
		//System.out.println("repaint()");
		super.repaint();
	}
	public void repaint(long tm){
		//System.out.println("repaint(long tm)");
		super.repaint(tm);
	}
	public void repaint(int x, int y, int w, int h){
		//System.out.println("repaint(int x, int y, int w, int h)");
		super.repaint(x, y, w, h);
	}
	public void repaint(long tm, int x, int y, int w, int h){
		//System.out.println("repaint(" + tm + ", " + x + ", " + y + ", " + w + ", " + h + ")");
		super.repaint(tm,x, y, w, h);
	}

	public void keyPressed(LwKeyEvent e) {
		long when = System.currentTimeMillis(); // risky
		int modif = e.getMask(); // risky
		KeyEvent ke = new KeyEvent(this, KeyEvent.KEY_PRESSED, when, modif, e.getKeyCode(), e.getKeyChar());
		processEvent(ke);
	}

	public void keyReleased(LwKeyEvent e) {
		long when = System.currentTimeMillis(); // risky
		int modif = e.getMask(); // risky
		KeyEvent ke = new KeyEvent(this, KeyEvent.KEY_RELEASED, when, modif, e.getKeyCode(), e.getKeyChar());
		processEvent(ke);
	}

	public void keyTyped(LwKeyEvent e) {
		long when = System.currentTimeMillis(); // risky
		int modif = e.getMask(); // risky
		KeyEvent ke = new KeyEvent(this, KeyEvent.KEY_TYPED, when, modif, e.getKeyCode(), e.getKeyChar());
		processEvent(ke);
	}

	public void mousePressed(LwMouseEvent e) {
		MouseEvent mev = new MouseEvent(
				this, MouseEvent.MOUSE_PRESSED, 0, 0, e.getX(), e.getY(), 0, false, 0);
		processEvent(mev);
	}
	
	public void mouseClicked(LwMouseEvent arg0) { }
	public void mouseEntered(LwMouseEvent arg0) { }
	public void mouseExited(LwMouseEvent arg0) { }
	public void mouseReleased(LwMouseEvent e) {
		MouseEvent mev = new MouseEvent(
				this, MouseEvent.MOUSE_RELEASED, 0, 0, e.getX(), e.getY(), 0, false, 0);
		processEvent(mev);
	}


}
