package org.gvsig.mobile.extension.base.info.functionality;

import java.util.ArrayList;

import org.gvsig.fmap.dal.exception.DataException;
import org.gvsig.fmap.dal.feature.FeatureSet;
import org.gvsig.fmap.mapcontext.layers.vectorial.FLyrVect;
import org.gvsig.mobile.core.concepts.Functionality;
import org.gvsig.mobile.core.interfaces.IGvSigContext;
import org.gvsig.mobile.core.interfaces.IGvSigMouseEvent;
import org.gvsig.mobile.ui.awt.mapcontrol.MapControl;
import org.osgi.framework.ServiceReference;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class ClearSelectionFunc extends Functionality {
	
	private static final Logger logger = LoggerFactory.getLogger(PointSelectionFunc.class);
	
	private IGvSigContext gvc;
	private MapControl mc;
	private FLyrVect layer;

	
	public ClearSelectionFunc() {
		super();
	}

	public void configure() {
		// TODO Auto-generated method stub
		
	}

	public boolean execution(ServiceReference gvSIGMobileRef) {
		gvc = (IGvSigContext)bc.getService(gvSIGMobileRef);
		mc = (MapControl) gvc.getMapControl();
		
		ArrayList infolyrs = mc.getLayersForInfo();
		
		if (infolyrs == null || infolyrs.size() != 1) {
			logger.warn("There must be exactly one layer for selection.");
			stop();
			return false;
		} else {
			layer = (FLyrVect) infolyrs.get(0);
			try {
				layer.getFeatureStore().setSelection(null);
			} catch (DataException e) {
				try {
					FeatureSet fs = layer.getFeatureStore().createFeatureSelection(); 
					layer.getFeatureStore().setSelection(fs);
				} catch (DataException e2) {
					logger.error("Unable to clear selection: " + e2.getMessage());
					stop();
					return false;
				}
			}
			stop();
			mc.setDirty();
			return true;
		}
	}

	public void onNewMouseEventListened(IGvSigMouseEvent event) {
		// TODO Auto-generated method stub
		
	}

}
