/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2006 Prodevelop and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   http://www.gvsig.gva.es
 *
 *    or
 *
 *   Prodevelop Integracin de Tecnologas SL
 *   Conde Salvatierra de lava , 34-10
 *   46004 Valencia
 *   Spain
 *
 *   +34 963 510 612
 *   +34 963 510 968
 *   gis@prodevelop.es
 *   http://www.prodevelop.es
 *
 *    or
 *
 *   Instituto de Robtica
 *   Apartado de correos 2085
 *   46071 Valencia
 *   (Spain)
 *   
 *   +34 963 543 577
 *   jjordan@robotica.uv.es
 *   http://robotica.uv.es
 *   
 */

package org.gvsig.mobile.extension.base.layer.dialog;

import java.awt.Dimension;

import org.gvsig.i18n.Messages;
import org.gvsig.mobile.ui.awt.WindowManager;
import org.gvsig.mobile.ui.lw.DialogConstants;
import org.gvsig.mobile.ui.lw.OkCancelDialog;
import org.osgi.framework.BundleContext;
import org.zaval.lw.LwFlowLayout;
import org.zaval.lw.LwLabel;
import org.zaval.lw.LwPanel;

public class CaptureScreenDialog extends OkCancelDialog {
	
	
	public CaptureScreenDialog(BundleContext bc) {
		super(false, bc, true);
		this.getCancelButton().setVisible(false);
	}
	public void actionPerformed(Object arg0, Object arg1) {
		WindowManager.getInstance().closeActivePanel();		
	}

	public LwPanel buildMainPanel() {
		LwPanel resp = new LwPanel();
		LwLabel l = DialogConstants.getDefaultLabel(Messages.getText("MapControl.32")); //$NON-NLS-2$
		resp.setLwLayout(new LwFlowLayout());
		resp.add(l);
//		+ ": " + img_name
//		resp.setLwLayout(new LwBorderLayout());
//		LwCombo test = new LwCombo();
//		test.getList().addItem("test");
//		resp.add(LwBorderLayout.NORTH, test);		
		return resp;
	}
	
	public Dimension getDesiredSize() {
		// TODO Auto-generated method stub
//		return new Dimension((int)LwToolkit.getScreenSize().getWidth() - 100, (int)LwToolkit.getScreenSize().getHeight()-100);
		if(DialogConstants.isResolution640())
			return new Dimension(400,400);
		else
			return new Dimension(200,200);
	}

	public boolean isMaximized() {
		// TODO Auto-generated method stub
		return false;
	}
	
	public String getTitle() {
		return Messages.getText("MapControl.33");
	}
}
