package org.gvsig.mobile.extension.base.navigation.functionality;

import java.awt.geom.Rectangle2D;

import org.gvsig.fmap.geom.primitive.Envelope;
import org.gvsig.fmap.geom.primitive.impl.Envelope2D;
import org.gvsig.fmap.mapcontext.ExtentHistory;

public class ZoomNextEnvelopeHistory {
	private static ExtentHistory extents=new ExtentHistory();

	public static void addNextEnvelope(Envelope r) {
		Rectangle2D newExtent = null;
		// Esto comprueba que el extent no es de anchura o altura = "0"
		// si lo es lo redimensiona.
		if (r != null) {
			if ((r.getMaximum(0) - r.getMinimum(0) == 0)
					|| (r.getMaximum(1) - r.getMinimum(1) == 0)) {
				newExtent = new Rectangle2D.Double(r.getMinimum(0) - 0.1, r
						.getMinimum(1) - 0.1, r.getMaximum(0) - r.getMinimum(0)
						+ 0.2, r.getMaximum(1) - r.getMinimum(1) + 0.2);
			} else {
				newExtent = new Rectangle2D.Double(r.getMinimum(0), r
						.getMinimum(1), Math.abs(r.getMaximum(0)
						- r.getMinimum(0)), Math.abs(r.getMaximum(1)
						- r.getMinimum(1)));
			}
		}

		if (newExtent != null) {
			extents.put(newExtent);
		}
	}
	
	public static Envelope getNextEnvelope(){
		Rectangle2D extent = extents.removePrev();
		return new Envelope2D(extent.getMinX(), extent.getMinY(), extent.getMaxX(), extent.getMaxY());
	}
	
	public static ExtentHistory clearNextEnvelopes() {
		return extents=new ExtentHistory();
	}
	
	public static boolean hashNext(){
		return extents.hasPrevious();
	}

}
