package org.gvsig.mobile.extension.base.project.dialog;

import java.awt.Image;

import org.gvsig.compat.CompatLocator;
import org.gvsig.i18n.Messages;
import org.gvsig.mobile.ui.awt.ImageUtils;
import org.gvsig.mobile.ui.lw.OkCancelDialog;
import org.osgi.framework.BundleContext;
import org.zaval.lw.LwFlowLayout;
import org.zaval.lw.LwImage;
import org.zaval.lw.LwLabel;
import org.zaval.lw.LwPanel;
import org.zaval.lw.LwToolkit;

public class AboutDialog extends OkCancelDialog {

	private LwPanel mainPanel = null;
	
	public AboutDialog(BundleContext bc) {
		super(true, bc, true);
		getCancelButton().setVisible(false);
	}
	
	public void actionPerformed(Object arg0, Object arg1) {
		close();
	}

	public LwPanel buildMainPanel() {
		
		if (mainPanel == null) {
			mainPanel = new LwPanel();
			LwFlowLayout lout =
				new LwFlowLayout(LwToolkit.LEFT, LwToolkit.TOP, LwToolkit.VERTICAL, 5); 
			mainPanel.setLwLayout(lout);
			
			int sz = 5;
			Image[] aimg = new Image[sz];
			aimg[0] = ImageUtils.getResourceImage(getBundleContext().getBundle(), "about_gvsig");
			aimg[1] = ImageUtils.getResourceImage(getBundleContext().getBundle(), "about_prode");
			aimg[2] = ImageUtils.getResourceImage(getBundleContext().getBundle(), "about_lisitt");
			aimg[3] = ImageUtils.getResourceImage(getBundleContext().getBundle(), "about_iver");
			aimg[4] = ImageUtils.getResourceImage(getBundleContext().getBundle(), "about_ue");
			String[] astr = new String[sz];
			astr[0] = "gvSIG Mobile (gvSIG Project)    ;http://www.gvsig.org    ";
			astr[1] = "Prodevelop S.L.    ;Pl. Don Juan Villarrasa 14, 5    ;CP 46001 Valencia (Spain)    ;http://www.prodevelop.es    ";
			astr[2] = "LISITT    ;Universitat de Valencia (Spain)    ;http://robotica.uv.es    ";
			astr[3] = "IVER Tecnologias    ;C/ Lerida 20    ;CP 46009 Valencia (Spain)    ;http://www.iver.es    ";
			astr[4] = "Co-funded by European Union    ";

			LwImage[] lwimg = new LwImage[sz];
			LwLabel[] lwlbl = null;
			for (int i=0; i<sz; i++) {
				lwimg[i] = new LwImage(aimg[i]);;
				lwlbl = getLabels(astr[i]);
				mainPanel.add(lwimg[i]);
				for (int j=0; j<lwlbl.length; j++) {
					mainPanel.add(lwlbl[j]);
				}
			}

		}
		return mainPanel;
	}

	private LwLabel[] getLabels(String stri) {
		
		String[] splstr = CompatLocator.getStringUtils().split(stri, ";");
		int len = splstr.length;
		LwLabel[] resp = new LwLabel[len+1];
		for (int i=0; i<len; i++) {
			resp[i] = new LwLabel(splstr[i]);
//			int ww = resp[i].getWidth();
//			int hh = resp[i].getHeight();
//			resp[i].setSize(ww,(2*hh)/3);
//			resp[i].setPSSize(ww,(2*hh)/3);
		}
		resp[len] = new LwLabel("...");
		return resp;
	}

	public String getTitle() {
		// TODO Auto-generated method stub
		return Messages.getText("About_dialog");
	}

}
