package org.gvsig.mobile.extension.base.project.functionality;

import java.io.FileInputStream;

import org.gvsig.mobile.core.concepts.Functionality;
import org.gvsig.mobile.core.interfaces.IGvSigContext;
import org.gvsig.mobile.core.interfaces.IGvSigMouseEvent;
import org.gvsig.mobile.project.Project;
import org.gvsig.mobile.ui.awt.mapcontrol.MapControl;
import org.gvsig.mobile.ui.lw.FileChooserDialog;
import org.gvsig.mobile.ui.lw.FileChooserListener;
import org.gvsig.mobile.ui.lw.UIConstants;
import org.gvsig.tools.ToolsLocator;
import org.gvsig.tools.persistence.PersistenceManager;
import org.gvsig.tools.persistence.PersistentState;
import org.osgi.framework.ServiceReference;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class ProjectOpenFunc extends Functionality implements FileChooserListener {
	
	final static private Logger logger =
		LoggerFactory.getLogger(ProjectOpenFunc.class);

	private ServiceReference servRef;
	private MapControl canvas;

	public ProjectOpenFunc() {
		super();
	}

	public void configure() {
		// TODO Auto-generated method stub
		
	}

	public boolean execution(ServiceReference gvSIGMobileRef) {
		try {
			servRef = gvSIGMobileRef;
			FileChooserDialog f = new FileChooserDialog(this, null, new String[][]{UIConstants.FILTER_GVM}, FileChooserDialog.DIALOG_TYPE_SELECT);		
			f.showDialog();
			super.stop();
			return true;
		} catch (Exception e) {
			logger.error("While showing dialog: " + e.getMessage());
			return false;
		}
	}

	public void onNewMouseEventListened(IGvSigMouseEvent event) {
		// TODO Auto-generated method stub
		
	}

	public void fileSelected(String path) {
		
		
		PersistenceManager pma = ToolsLocator.getPersistenceManager();
		FileInputStream fis = null;
		PersistentState sta = null;
		Project openprj = new Project();
		

		try {
			fis = new FileInputStream(path);
			sta = pma.loadState(fis);
			fis.close();
			
			// ToolsLocator.getPersistenceManager().
			openprj = (Project) pma.create(sta);
			// pma.create(state)
			// openmc = (MapContext) pma.create(sta);
			// openmc.loadFromState(sta);

			if (canvas == null) {
				IGvSigContext gv = (IGvSigContext) bc.getService(servRef);
				canvas = (MapControl)gv.getMapControl();
			}
			openprj.getMapContext().getViewPort().addViewPortListener(canvas);
			canvas.initWith(openprj); //openmc, new File(path));
			canvas.initAcetateLayer();
			// canvas.getMapContext().setD
		} catch (Exception ex) {
			logger.error("While loading mapcontext: " + ex.getMessage());
			ex.printStackTrace();
		}
		
	}
}
