package org.gvsig.mobile.extension.base.project.functionality;

import java.io.FileOutputStream;

import org.gvsig.mobile.core.concepts.Functionality;
import org.gvsig.mobile.core.interfaces.IGvSigContext;
import org.gvsig.mobile.core.interfaces.IGvSigMouseEvent;
import org.gvsig.mobile.project.Project;
import org.gvsig.mobile.ui.awt.mapcontrol.MapControl;
import org.gvsig.tools.ToolsLocator;
import org.gvsig.tools.persistence.PersistenceManager;
import org.gvsig.tools.persistence.PersistentState;
import org.osgi.framework.ServiceReference;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class ProjectSaveFunc extends Functionality {
	
	final static private Logger logger =
		LoggerFactory.getLogger(ProjectSaveFunc.class);

	private MapControl canvas;
	
	public ProjectSaveFunc() {
		super();
	}

	public void configure() {
		// TODO Auto-generated method stub
		
	}

	public boolean execution(ServiceReference gvSIGMobileRef) {
		try {

			if (this.canvas == null) {
				IGvSigContext gv = (IGvSigContext)bc.getService(gvSIGMobileRef);
				this.canvas = (MapControl)gv.getMapControl();
			}
			
			Project pr = canvas.getProject(); // 
			PersistenceManager pma = ToolsLocator.getPersistenceManager();
			
			try {
				PersistentState psta = pma.getState(pr); 
				FileOutputStream fos = new FileOutputStream(pr.getProjectFile());
				pma.saveState(psta, fos);
				fos.close();
			} catch (Exception ex) {
				logger.error("While storing project: " + ex.getMessage());
			}
			
			super.stop();
			return true;
			
		} catch (Exception e) {
			logger.error("While storing project: " + e.getMessage());
			return false;
		}
	}

	public void onNewMouseEventListened(IGvSigMouseEvent event) {
		// TODO Auto-generated method stub
		
	}

		

}
