package org.gvsig.mobile.extension.editing.dialog;

import java.util.ArrayList;

import org.gvsig.i18n.Messages;
import org.gvsig.mobile.app.MainFrame;
import org.gvsig.mobile.core.auxfunctions.FunctionalityResolutor;
import org.gvsig.mobile.core.concepts.Functionality;
import org.gvsig.mobile.core.exceptions.GvSigServiceNotFoundException;
import org.gvsig.mobile.core.extensions.interfaces.IFunctionality;
import org.gvsig.mobile.ui.awt.WindowManager;
import org.gvsig.mobile.ui.awt.mapcontrol.MapControl;
import org.gvsig.mobile.ui.lw.OkCancelDialog;
import org.osgi.framework.BundleContext;
import org.zaval.lw.LwCombo;
import org.zaval.lw.LwComponent;
import org.zaval.lw.LwContainer;
import org.zaval.lw.LwFlowLayout;
import org.zaval.lw.LwGridLayout;
import org.zaval.lw.LwLabel;
import org.zaval.lw.LwPanel;
import org.zaval.lw.LwTextField;
import org.zaval.lw.LwToolkit;

/**
 * @author Vicente Caballero Navarro
 */
public class InsertAnnotationDialog extends OkCancelDialog {
    private MainFrame   m   = null;
    private MapControl  map = null;
    
    private LwTextField annotation;
    private LwTextField angle;
    private LwTextField color;
    private LwTextField height;
    private LwCombo     font;
    private LwCombo     units;
    
    public InsertAnnotationDialog(boolean scrollable, BundleContext bc,
            MainFrame m, MapControl map) {
        super(scrollable, bc);
        this.getCancelButton().setVisible(true);
        this.m = m;
        this.map = map;
        // super.add(LwBorderLayout.WEST, this.buildMainPanel());
    }
    
    private void execute(String functionalityID) {
        try {
            IFunctionality func = FunctionalityResolutor.solve(functionalityID,
                    "", "", "", "", "", "", getBundleContext());
            ((Functionality) func).runFunctionality();
            // FunctionalityResolutor
            // .execute(func, getBundleContext());
        } catch (GvSigServiceNotFoundException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
    
    public void actionPerformed(Object src, Object data) {
        // if (src == finalPointButton){
        // execute("es.iver.gvsig.extension.editing.SnappingFinalPointFunc.1.0.0.functionality");
        // } else if (src == nearestPointButton) {
        // execute("es.iver.gvsig.extension.editing.SnappingNearestPointFunc.1.0.0.functionality");
        // } else
        if (src == this.getOkButton()) {
            execute("es.iver.gvsig.extension.editing.AddAnnotationFunc.1.0.0.functionality");
            WindowManager.getInstance().closeActivePanel();
        } else if (src == this.getCancelButton()) {
            WindowManager.getInstance().closeActivePanel();
        }
    }
    
    private LwContainer getToolBar(String name, LwComponent field) {
        LwGridLayout toolbar1Layout = new LwGridLayout(2, 1);
        LwContainer toolbar1 = new LwPanel();
        // toolbar1.setBackground(Color.white);
        toolbar1.setLwLayout(toolbar1Layout);
        
        toolbar1.add(new LwLabel(name));
        toolbar1.add(field);
        return toolbar1;
    }
    
    public LwPanel buildMainPanel() {
        
        annotation = new LwTextField();
        annotation.setPSSize(150, 30);
        LwContainer toolbar1 = getToolBar(Messages.getText("InsertAnnotationDialog.1"),
                annotation);
        
        angle = new LwTextField();
        angle.setPSSize(150, 30);
        LwContainer toolbar2 = getToolBar(Messages.getText("InsertAnnotationDialog.2"), angle);
        
        color = new LwTextField();
        color.setPSSize(150, 30);
        LwContainer toolbar3 = getToolBar(Messages.getText("InsertAnnotationDialog.3"), color);
        
        height = new LwTextField();
        height.setPSSize(150, 30);
        LwContainer toolbar4 = getToolBar(Messages.getText("InsertAnnotationDialog.4"), height);
        
        units = new LwCombo();
        units.setPSSize(150, 30);
        LwContainer toolbar5 = getToolBar(Messages.getText("InsertAnnotationDialog.5"), units);
        
        font = new LwCombo();
        font.setPSSize(150, 30);
        LwContainer toolbar6 = getToolBar(Messages.getText("InsertAnnotationDialog.6"), font);
        
        LwPanel resp = new LwPanel();
        LwFlowLayout resp1Layout = new LwFlowLayout(LwToolkit.LEFT,
                LwToolkit.TOP, LwToolkit.VERTICAL, 1);
        resp.setLwLayout(resp1Layout);
        
        resp.add(toolbar1);
        resp.add(toolbar2);
        resp.add(toolbar3);
        resp.add(toolbar4);
        resp.add(toolbar5);
        resp.add(toolbar6);
        
        return resp;
    }
    
    public String getTitle() {
        return Messages.getText("InsertAnnotationDialog.0");
    }
    
    public ArrayList getProperties() {
        ArrayList properties = new ArrayList();
        properties.add(annotation.getText());
        properties.add(angle.getText());
        properties.add(color.getText());
        properties.add(height.getText());
        // properties.add(units.getList().getSelected().toString());
        // properties.add(font.getList().getSelected().toString());
        return properties;
    }
    
}
