package org.gvsig.mobile.extension.editing.functionality;

import java.awt.geom.PathIterator;
import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;

import org.gvsig.fmap.dal.exception.DataException;
import org.gvsig.fmap.dal.exception.ReadException;
import org.gvsig.tools.dispose.DisposableIterator; 
import org.gvsig.fmap.dal.feature.EditableFeature;
import org.gvsig.fmap.dal.feature.Feature;
import org.gvsig.fmap.dal.feature.FeatureSelection;
import org.gvsig.fmap.dal.feature.FeatureStore;
import org.gvsig.fmap.geom.Geometry;
import org.gvsig.fmap.geom.exception.CreateGeometryException;
import org.gvsig.fmap.geom.primitive.GeneralPathX;
import org.gvsig.fmap.mapcontext.layers.vectorial.FLyrVect;
import org.gvsig.mobile.core.constants.GvSigMouseEventType;
import org.gvsig.mobile.core.interfaces.IGvSigMouseEvent;
import org.osgi.framework.ServiceReference;

/**
 * @author Vicente Caballero Navarro
 */
public class AddMiddleVertexFunc extends EditingFunctionality implements InsertablePoint{
    private FeatureSelection selection       = null;
    private Feature          featureToChange = null;
//    private Point2D          point1          = null;
    
    public boolean execution(ServiceReference gvSIGMobileRef) {
        boolean execute = super.execution(gvSIGMobileRef);
        try {
            selection = getEditingLayer().getFeatureStore()
                    .getFeatureSelection();
            drawHandlers(selection);
        } catch (DataException e) {
            e.printStackTrace();
        }
        return execute;
    }
    
    public AddMiddleVertexFunc() {
        super();
    }
    
    public void configure() {
        // TODO Auto-generated method stub
        
    }
    
    public void onNewMouseEventListened(IGvSigMouseEvent event) {
        int type = event.getID();
            if (type == GvSigMouseEventType.MOUSE_PRESSED) {
                Point2D point = getHandlerAdjustedPoint();
                addPoint(point);
            }
       
    }
    
    private Geometry addVertex(Geometry geome,Point2D p,Rectangle2D rect) throws CreateGeometryException {
    	Geometry geometryCloned=geome.cloneGeometry();
    	Geometry geom1=null;
    	GeneralPathX gpxAux;
    	boolean finish=false;
    	GeneralPathX newGp = new GeneralPathX();
        double[] theData = new double[6];

            PathIterator theIterator;
            int theType;
            int numParts = 0;
            Point2D pLast=new Point2D.Double();
            Point2D pAnt = new Point2D.Double();
            Point2D firstPoint=null;
            theIterator = geome.getPathIterator(null,getFlatNess()); //, flatness);
            int numSegmentsAdded = 0;
            while (!theIterator.isDone()) {
                theType = theIterator.currentSegment(theData);
                switch (theType) {
                    case PathIterator.SEG_MOVETO:
                    	pLast.setLocation(theData[0], theData[1]);
                    	if (numParts==0)
                    		firstPoint=(Point2D)pLast.clone();
                    	numParts++;

                    	gpxAux=new GeneralPathX();
                    	gpxAux.moveTo(pAnt.getX(),pAnt.getY());
                    	gpxAux.lineTo(pLast.getX(),pLast.getY());
                    	geom1=geomManager.createCurve(gpxAux,Geometry.SUBTYPES.GEOM2D);
                    	if (geom1.intersects(rect)){
                    		finish=true;
                    		newGp.moveTo(pLast.getX(), pLast.getY());
                    		//newGp.lineTo(pLast.getX(),pLast.getY());
                    	}else{
                    		newGp.moveTo(pLast.getX(), pLast.getY());
                    	}
                        pAnt.setLocation(pLast.getX(), pLast.getY());
                        numSegmentsAdded++;
                        break;

                    case PathIterator.SEG_LINETO:
                    	pLast.setLocation(theData[0], theData[1]);
                    	gpxAux=new GeneralPathX();
                    	gpxAux.moveTo(pAnt.getX(),pAnt.getY());
                    	gpxAux.lineTo(pLast.getX(),pLast.getY());
                    	geom1=geomManager.createCurve(gpxAux,Geometry.SUBTYPES.GEOM2D);
                    	if (geom1.intersects(rect)){
                    		newGp.lineTo(p.getX(), p.getY());
                    		newGp.lineTo(pLast.getX(),pLast.getY());
                    	}else{
                    		newGp.lineTo(pLast.getX(), pLast.getY());
                    	}
                    	pAnt.setLocation(pLast.getX(), pLast.getY());
                        numSegmentsAdded++;
                        break;

                    case PathIterator.SEG_QUADTO:
                        newGp.quadTo(theData[0], theData[1], theData[2], theData[3]);
                        numSegmentsAdded++;
                        break;

                    case PathIterator.SEG_CUBICTO:
                        newGp.curveTo(theData[0], theData[1], theData[2], theData[3], theData[4], theData[5]);
                        numSegmentsAdded++;
                        break;

                    case PathIterator.SEG_CLOSE:
                        //if (numSegmentsAdded < 3){
                        	gpxAux=new GeneralPathX();
                        	gpxAux.moveTo(pAnt.getX(),pAnt.getY());
                        	gpxAux.lineTo(firstPoint.getX(),firstPoint.getY());
                        	geom1=geomManager.createCurve(gpxAux,Geometry.SUBTYPES.GEOM2D);
                        	if (geom1.intersects(rect)|| finish){
                        		newGp.lineTo(p.getX(), p.getY());
                        		newGp.lineTo(pLast.getX(),pLast.getY());
                        	}else{
                        		newGp.lineTo(pLast.getX(), pLast.getY());
                        	}
                        //}
                        newGp.closePath();
                        break;
                } //end switch

                theIterator.next();
            } //end while loop
            Geometry shp = null;
            switch (geometryCloned.getType())
            {
                case Geometry.TYPES.POINT: //Tipo punto
                    shp = geomManager.createPoint(pLast.getX(), pLast.getY(),Geometry.SUBTYPES.GEOM2D);
                    break;

                case Geometry.TYPES.CURVE:
                    shp = geomManager.createCurve(newGp,Geometry.SUBTYPES.GEOM2D);
                    break;
                case Geometry.TYPES.SURFACE:
                    shp = geomManager.createSurface(newGp,Geometry.SUBTYPES.GEOM2D);
                    break;
            }
            return shp;


    }
    
    public boolean isApplicable() {
        FLyrVect lv = getEditingLayer();
        try {
            int type = lv.getShapeType();
            if (
            		type == Geometry.TYPES.CURVE ||
            		type == Geometry.TYPES.SURFACE ||
            		type == Geometry.TYPES.MULTICURVE ||
            		type == Geometry.TYPES.MULTISURFACE ||
            		type == Geometry.TYPES.GEOMETRY) {
                return true;
            }
        } catch (ReadException e) {
            e.printStackTrace();
        }
        return false;
    }

    public void addPoint(Point2D point) {
    	try{
    		double tol=getViewPort().toMapDistance(TOLHANDLER);
    		Rectangle2D rec = new Rectangle2D.Double(point.getX() - tol
    				* 0.5, point.getY() - tol * 0.5, tol, tol);
    		DisposableIterator features = selection.iterator();
//    		double distance1 = Double.MAX_VALUE;
    		//        double distance2 = Double.MAX_VALUE;

    		while (features.hasNext()) {
    			featureToChange = (Feature) features.next();
//    			Geometry geometry = featureToChange.getDefaultGeometry();
//    			Handler[] handlers = geometry
//    			.getHandlers(Geometry.SELECTHANDLER);
//    			for (int j = 0; j < handlers.length; j++) {
//    				double distance = point
//    				.distance(handlers[j].getPoint());
//    				if (distance1 > distance) {
////    					if (point1 != null)
////    						point2 = new Point2D.Double(point1.getX(),
////    								point1.getY());
//    					//                    distance2 = distance1;
////    					point1 = handlers[j].getPoint();
//    					distance1 = distance;
//    				}
//    			}

    			FeatureStore fs = getEditingLayer().getFeatureStore();
    			Geometry geom = addVertex(featureToChange.getDefaultGeometry(), point, rec);
    			EditableFeature eFeature = featureToChange.getEditable();
    			eFeature.setGeometry(fs.getDefaultFeatureType()
    					.getDefaultGeometryAttributeName(), geom);
    			fs.update(eFeature);

    			features.dispose();
    			selection.dispose();
    			repaintMap();
    		}
    	} catch (DataException e) {
    		e.printStackTrace();
    	} catch (CreateGeometryException e) {
    		e.printStackTrace();
    	}
    }

}
