package org.gvsig.mobile.extension.editing.functionality;

import org.gvsig.fmap.dal.exception.DataException;
import org.gvsig.fmap.dal.exception.ReadException;
import org.gvsig.tools.dispose.DisposableIterator; 
import org.gvsig.fmap.dal.feature.Feature;
import org.gvsig.fmap.dal.feature.FeatureSelection;
import org.gvsig.fmap.dal.feature.FeatureSet;
import org.gvsig.fmap.dal.feature.FeatureStore;
import org.gvsig.fmap.dal.feature.exception.NeedEditingModeException;
import org.gvsig.mobile.core.interfaces.IGvSigMouseEvent;
import org.osgi.framework.ServiceReference;

/**
 * @author Vicente Caballero Navarro
 */
public class RemoveFunc extends EditingFunctionality {
    private FeatureSelection selection = null;
    
    public boolean execution(ServiceReference gvRef) {
    	
        FeatureStore fs = getEditingLayer().getFeatureStore();
        
        DisposableIterator iterator = null;
        try {
        	
            fs.beginEditingGroup("Remove geometries...");
            FeatureSelection selection = fs.createFeatureSelection();
            selection.select((FeatureSet) fs.getSelection());
            iterator = selection.iterator();
            while (iterator.hasNext()) {
                Feature feature = (Feature) iterator.next();
                fs.delete(feature);
            }
        } catch (ReadException e) {
            e.printStackTrace();
        } catch (DataException e) {
            e.printStackTrace();
        } finally {
        	
            if (iterator != null) {
                iterator.dispose();
            }

            try {
                fs.endEditingGroup();
            } catch (NeedEditingModeException e) {
                e.printStackTrace();
            }
        }
        
        super.stop();

        repaintMap();

        return super.execution(gvRef);
    }
    
    public void configure() {
    }
    
    public void onNewMouseEventListened(IGvSigMouseEvent event) {
    }
    
    public boolean isApplicable() {
        try {
            selection = getEditingLayer().getFeatureStore()
                    .getFeatureSelection();
            if (selection.getSelectedCount() > 0) {
                return true;
            }
        } catch (DataException e) {
            e.printStackTrace();
        }
        return false;
    }
}
