package org.gvsig.mobile.extension.gps.functionality;

import org.gvsig.location.LocationProvider;
import org.gvsig.mobile.core.concepts.Functionality;
import org.gvsig.mobile.core.interfaces.IGvSigContext;
import org.gvsig.mobile.core.interfaces.IGvSigMouseEvent;
import org.gvsig.mobile.extension.gps.dialog.GPSActivityDialog;
import org.gvsig.mobile.gps.GPSResolutor;
import org.osgi.framework.ServiceReference;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class GPSActivityFunc extends Functionality {
	private static final Logger logger = LoggerFactory.getLogger(GPSActivityFunc.class);
	GPSActivityDialog gpsConsole;
	
	public GPSActivityFunc() {
		super();
	}

	public void configure() {
		// TODO Auto-generated method stub
		
	}

	public boolean execution(ServiceReference gvSIGMobileRef) {
		try {
			IGvSigContext gv = (IGvSigContext)this.bc.getService(gvSIGMobileRef);
			
			gpsConsole = new GPSActivityDialog(this.getBundleContext());
			addListenerToActivityDialog();
			gpsConsole.showDialog();
			
			super.stop();
			
			return true;
		} catch (Exception e) {
			logger.error("GPS ACTIVITY ERROR : \n"+e.fillInStackTrace().toString());
			return false;
		}
	}
	
	public void  addListenerToActivityDialog ()
	{
		LocationProvider provider = GPSResolutor.getLocationProvider();
		if (provider != null) {
			// Register cursor as listener for location updates
			provider.addLocationListener(gpsConsole, 1, LocationProvider.PROVIDER_DEFAULT, 
					LocationProvider.PROVIDER_DEFAULT);
			
			provider.addPropertyChangeListener(gpsConsole);
		}
	}

	public void onNewMouseEventListened(IGvSigMouseEvent event) {
		// TODO Auto-generated method stub
		
	}

}
