/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2006 Prodevelop and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *   Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *   +34 963862235
 *   gvsig@gva.es
 *   http://www.gvsig.gva.es
 *
 *    or
 *
 *   Prodevelop Integracin de Tecnologas SL
 *   Conde Salvatierra de lava , 34-10
 *   46004 Valencia
 *   Spain
 *
 *   +34 963 510 612
 *   +34 963 510 968
 *   gis@prodevelop.es
 *   http://www.prodevelop.es
 *
 *    or
 *
 *   Instituto de Robtica
 *   Apartado de correos 2085
 *   46071 Valencia
 *   (Spain)
 *   
 *   +34 963 543 577
 *   jjordan@robotica.uv.es
 *   http://robotica.uv.es
 *   
 */
package org.gvsig.mobile.ui.lw;

import java.awt.Dimension;
import java.awt.Toolkit;

public class UIConstants {
	
	public static final String TB_EDITING_KEY = "EDITING";
	public static final String TB_EDITING_DESC = "Editing Toolbar";
	
	public static final String TB_NAV_KEY = "NAV";
	public static final String TB_NAV_DESC = "Navigation Toolbar";
	
	public static final String TB_INFO_KEY = "INFO";
	public static final String TB_INFO_DESC = "Info Toolbar";
	
	public static final String TB_GPS_KEY = "GPS";
	public static final String TB_GPS_DESC = "GPS Toolbar";
	
	public static final String TB_LAYERS_KEY = "LAYERS";
	public static final String TB_LAYERS_DESC = "Layers Toolbar";
	
	public static final String TB_PROJECT_KEY = "PROJECT";
	public static final String TB_PROJECT_DESC = "Project Toolbar";
	
	public static final String ADD_ECW_KEY = "ADDECW";
	public static final String ADD_ECW_DESC = "Add raster layer";
	
	public static final String ADD_SHP_KEY = "ADDSHP";
	public static final String ADD_SHP_DESC = "Add vectorial layer";
	
	public static final String ADD_WMS_KEY = "ADDWMS";
	public static final String ADD_WMS_DESC = "Add WMS layer";
	
	public static final String CAPT_KEY = "CAPT";
	public static final String CAPT_DESC = "Capture screen";
	
	public static final String EXPORT_KEY = "EXPORT";
	public static final String EXPORT_DESC = "Export layer";
	
	public static final String EXIT_KEY = "EXIT";
	public static final String EXIT_DESC = "Exit program";
	
	public static final String NEW_KEY = "NEW";
	public static final String NEW_DESC = "New project";
	
	public static final String OPEN_KEY = "OPEN";
	public static final String OPEN_DESC = "Open project";
	
	public static final String PROP_KEY = "PROP";
	public static final String PROP_DESC = "View project properties";
	
	public static final String SAVEAS_KEY = "SAVEAS";
	public static final String SAVEAS_DESC = "Save as";
	
	public static final String SAVE_KEY = "SAVE";
	public static final String SAVE_DESC = "Save";
	
	public static final String TOC_KEY = "TOC";
	public static final String TOC_DESC = "Table of layers";
	
	public static final String GPSAV_KEY = "GPSAV";
	public static final String GPSAV_DESC = "GPS Auto vertex";
	
	public static final String GPSV_KEY = "GPSV";
	public static final String GPSV_DESC = "GPS Vertex";
	
	public static final String LINE_KEY = "LINE";
	public static final String LINE_DESC = "Add line";
	
	public static final String POINT_KEY = "POINT";
	public static final String POINT_DESC = "Add point";
	
	public static final String POLY_KEY = "POLY";
	public static final String POLY_DESC = "Add polygon";
	
	public static final String SETTINGS_KEY = "SETTINGS";
	public static final String SETTINGS_DESC = "Settings";
	
	public static final String GPS_CONNECT_KEY = "GPSC";
	public static final String GPS_CONNECT_DESC = "Connect GPS";
	
	public static final String GPS_CONFIG_KEY = "GPSCO";
	public static final String GPS_CONFIG_DESC = "Configure GPS";
	
	public static final String GPS_TRACK_KEY = "GPSTR";
	public static final String GPS_TRACK_DESC = "GPS tracklog";
	
	public static final String GPS_ACT_KEY = "GPSACT";
	public static final String GPS_ACT_DESC = "GPS activity";
	
	public static final String GPS_VIEWP_KEY = "GPSVP";
	public static final String GPS_VIEWP_DESC = "GPSVPD";
	
	public static final String GPS_VIEWC_KEY = "GPSVC";
	public static final String GPS_VIEWC_DESC = "GPSVCD";
	
	public static final String GPS_FINISH_KEY = "GPSF";
	public static final String GPS_FINISH_DESC = "GPSVFD";
	
	public static final String GPS_WAY_KEY = "GPSW";
	public static final String GPS_WAY_DESC = "GPSVWD";
	
	public static final String ZOOM_IN_KEY = "ZOOMIN";
	public static final String ZOOM_IN_DESC = "Zoom in";
	
	public static final String ZOOM_OUT_KEY = "ZOOMOUT";
	public static final String ZOOM_OUT_DESC = "Zoom out";
	
	public static final String ZOOM_NEXT_KEY = "ZOOMNEXT";
	public static final String ZOOM_NEXT_DESC = "Zoom next";
	
	public static final String ZOOM_PREV_KEY = "ZOOMPREV";
	public static final String ZOOM_PREV_DESC = "Zoom previous";
	
	public static final String ZOOM_ALL_KEY = "ZOOMALL";
	public static final String ZOOM_ALL_DESC = "Zoom to all";
	
	public static final String ZOOM_RECT_KEY = "ZOOMREC";
	public static final String ZOOM_RECT_DESC = "Zoom rectangle";
	
	public static final String PAN_KEY = "PAN";
	public static final String PAN_DESC = "Pan";
	
	public static final String CENTER_KEY = "center";
	public static final String CENTER_DESC = "Center";
	
	public static final String INFO_KEY = "INFO";
	public static final String INFO_DESC = "Info";
	
	public static final String SEARCH_KEY = "SEARCH";
	public static final String SEARCH_DESC = "Search attributes";
	
	public static final String INFO_ZOOM_KEY = "INFOZ";
	public static final String INFO_ZOOM_DESC = "INFOZD";
	
	public static final String INFO_SELP_KEY = "INFOSELP";
	public static final String INFO_SELP_DESC = "INFOSELPD";
	
	public static final String INFO_SELR_KEY = "INFOSELR";
	public static final String INFO_SELR_DESC = "INFOSELRD";
	
	public static final String INFO_CLEAR_KEY = "CLEAR";
	public static final String INFO_CLEAR_DESC = "CLEARD";
	
	public static final String INFO_MEASD_KEY = "MEASD";
	public static final String INFO_MEASD_DESC = "MEASDD";
	
	public static final String INFO_MEASA_KEY = "MEASA";
	public static final String INFO_MEASA_DESC = "MEASAD";
	
	public static final String INFO_MEASP_KEY = "MEASP";
	public static final String INFO_MEASP_DESC = "MEASPD";
	
	public static final String TEXT_FILE_CHOOSER = "File Chooser";
	public static final String TEXT_COLOR_CHOOSER = "Color Chooser";
	public static final String TEXT_WMS_DIALOG = "WMS dialog";
	public static final String TEXT_CAPT_IMG = "Imagen capturada";
	public static final String TEXT_EXPORT_LAYER = "Export layer";
	public static final String TEXT_NAME = "Nombre: ";
	public static final String TEXT_PATH = "Ruta: ";
	public static final String TEXT_DESC = "Descripcin: ";
	public static final String TEXT_CREATED = "Creado: ";
	public static final String TEXT_MODIFIED = "Actualizado: ";
	public static final String TEXT_BG = "Fondo: ";
	public static final String TEXT_LAYER = "Capa: ";
	public static final String TEXT_COLUMN = "Columna: ";
	public static final String TEXT_OP = "Op.: ";
	public static final String TEXT_VALOR = "Valor: ";
	public static final String TEXT_SEARCH_ATT = "Buscar por atributos";
	
	
	
	
	public static final String ICON_SHP = "addSHP_black"; 
	public static final String ICON_ECW = "addECW_black";
	public static final String ICON_WMS = "toc_layer_add_wms_black";
	public static final String ICON_TOC = "layers_properties_black";
	public static final String ICON_EXPORT = "filesaveas_black";
	public static final String ICON_CAPT = "capture_black";//"img24_export_image_black";
	public static final String ICON_GPSAV = "editing_gps_add_vertex_auto_black";
	public static final String ICON_GPSV = "editing_gps_add_vertex_black";
	public static final String ICON_LINE = "editing_geometry_insert_line_black";
	public static final String ICON_POINT = "editing_geometry_insert_point_black";
	public static final String ICON_POLY = "editing_geometry_insert_polygon_black";
	public static final String ICON_SETTINGS = "settings";
	public static final String ICON_PROJECT_EXIT = "exit_black";
	public static final String ICON_PROJECT_NEW = "project_new_3_black";
	public static final String ICON_PROJECT_OPEN = "project_open_black";
	public static final String ICON_PROJECT_PROPS = "project_properties_black";
	public static final String ICON_PROJECT_SAVEAS = "project_save_as_black";
	public static final String ICON_PROJECT_SAVE = "project_save_black";
	public static final String ICON_GPS_FINISH = "finish_flag_black";
	public static final String ICON_GPS_CONFIG = "gps_2_config_black";
	public static final String ICON_GPS_CONNECT = "gps_2_connect_black";
	public static final String ICON_GPS_TRACK = "gps_2_tracklog_black_2";
	public static final String ICON_GPS_VIEWC = "gps_2_view_coordinates_black";
	public static final String ICON_GPS_VIEWP = "gps_2_view_position_black";
	public static final String ICON_GPS_ACT = "gps_activity_black";
	public static final String ICON_GPS_WAY = "gps_waypoint_add_black";
	public static final String ICON_NAV_PAN = "pan_black";
	public static final String ICON_NAV_CENTER = "recenter_black";	
	public static final String ICON_NAV_ZOOM_ALL = "zoom_extension_black";
	public static final String ICON_NAV_ZOOM_PREV = "zoom_previous_black";
	public static final String ICON_NAV_ZOOM_NEXT = "zoom_next_black";
	public static final String ICON_NAV_ZOOM_IN = "zoom_in_black";
	public static final String ICON_NAV_ZOOM_OUT = "zoom_out_black";
	public static final String ICON_NAV_ZOOM_WIN = "zoom_window_black";
	public static final String ICON_INFO = "info_black";
	public static final String ICON_INFO_ZOOM = "zoom_selection_black";
	public static final String ICON_INFO_SEARCH = "search_black";
	public static final String ICON_INFO_SELP = "select_point_2_black";
	public static final String ICON_INFO_SELR = "select_rectangle_2_black";
	public static final String ICON_INFO_CLEAR = "select_clean_black";	
	public static final String ICON_INFO_MEASD = "measure_distance_3_black";
	public static final String ICON_INFO_MEASA = "measure_area_3_black";
	public static final String ICON_INFO_MEASP = "measure_position_3_black";
	
	public static final String ICON_GROUP_LAYERS = "group_layers_floating";
	public static final String ICON_GROUP_NAV = "group_navigation_floating_tab";
	public static final String ICON_GROUP_INFO = "group_info_floating_filled";
	public static final String ICON_GROUP_PROJ = "group_project_2_floating_tab";
	public static final String ICON_GROUP_GPS = "group_gps_floating_tab";
	public static final String ICON_GROUP_EDITING = "group_editing";
	public static final String ICON_COMBO = "menu_combo_down_black";
	
	public static final String[] FILTER_GVM = {"gvSIG Mobile Project", "gvm"};
	public static final String[] FILTER_ECW = {"ECW", "ecw"};
	public static final String[] FILTER_GPX = {"GPX", "gpx"};
	public static final String[] FILTER_KML = {"KML", "kml"};
	public static final String[] FILTER_KMZ = {"KMZ", "kmz"};
	public static final String[] FILTER_JPG = {"JPG", "jpg"};
	public static final String[] FILTER_GIF = {"GIF", "gif"};
	public static final String[] FILTER_PNG = {"PNG", "png"};
	public static final String[] FILTER_JPEG = {"JPEG", "jpeg"};
	public static final String[] FILTER_SHP = {"SHP", "shp"};
	public static final String[] FILTER_DBF = {"DBF", "dbf"};
	public static final String[] FILTER_GML = {"GML", "gml"};
	public static final String[] FILTER_TIFF = {"TIFF", "tiff"};
	public static final String[] FILTER_ALL = {"ALL", "*"};
	
	// ==================
	public static final int WAIT_TO_REFRESH_UI_MILISECS = 75;
	
	public static Dimension SCREEN_SIZE;
	
	static {
		SCREEN_SIZE = Toolkit.getDefaultToolkit().getScreenSize();
		// System.out.println("SCREEN_SIZE = " + SCREEN_SIZE.width);
	}

}
