/**
 *     Caption: J2SE/J2ME(Personal Profile) Light-Weight Visual Components Library
 *
 *     @author:     Andrei Vishnevsky
 *     @version:    4.50
 *
 * The latest product version is always available from the product's homepage:
 * http://www.lwvcl.com/
 *
 * Copyright (C) 2001-2005  Zaval Creative Engineering Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * (version 2) as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
package org.zaval.lw.misc;

import java.awt.Color;
import java.awt.Font;

import org.zaval.data.Item;
import org.zaval.lw.LwComponent;
import org.zaval.lw.LwImgRender;

public class CItem
extends Item
{
   private Font        font;
   private Color       color;
   private LwImgRender icon;
   private LwComponent editor;

   public CItem(Object data)  {
     this(data, null);
   }

   public CItem(Object data, LwImgRender i)  {
     super(data);
     setIcon (i);     
   }

   public void setIcon (LwImgRender i) {
     icon = i;
   }

   public void setFont (Font f) {
     font = f;
   }

   public void setColor (Color c) {
     color = c;
   }

   public void setEditor (LwComponent e) {
     editor = e;
   }

   public Font getFont () {
     return font;
   }

   public Color getColor () {
     return color;
   }

   public LwImgRender getIcon () {
     return icon;
   }

   public LwComponent getEditor () {
     return editor;
   }

   public void resetValue (Object data) {
     setValue (data);
   }
}

