/**
 *     Caption: J2SE/J2ME(Personal Profile) Light-Weight Visual Components Library
 *
 *     @author:     Andrei Vishnevsky
 *     @version:    4.50
 *
 * The latest product version is always available from the product's homepage:
 * http://www.lwvcl.com/
 *
 * Copyright (C) 2001-2005  Zaval Creative Engineering Group
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * (version 2) as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */
package org.zaval.lw.misc;

import java.awt.Color;

import org.zaval.data.Item;
import org.zaval.lw.LwComponent;
import org.zaval.lw.LwTextField;
import org.zaval.lw.LwView;
import org.zaval.lw.event.LwMouseEvent;
import org.zaval.lw.event.LwVCLEvent;

public class LwCustomTreeEditor
implements org.zaval.lw.LwEditorProvider
{
   private LwComponent defEditor;

   public LwCustomTreeEditor() {
     this (null);
   }

   public LwCustomTreeEditor(LwComponent c) {
     setDefEditor (c);
   }

   public LwComponent getEditor(LwComponent src, Object item)
   {
     LwComponent editor = defEditor;
     if (item instanceof CItem && ((CItem)item).getEditor () != null)
       editor = ((CItem)item).getEditor();

     if (editor != null && LwUtils.fillEditorByData(((Item)item).getValue(), editor))
       return editor;

     return null;
   }

   public Object fetchEditedValue (Object item, LwComponent editor) {
     return LwUtils.fetchEditedData (((Item)item).getValue(), editor);
   }

   public boolean shouldStartEdit(Object o, LwVCLEvent e) {
     return e.getID() == LwMouseEvent.MOUSE_CLICKED && ((LwMouseEvent)e).getClickCount() >= 1;
   }

   public void setDefEditor (LwComponent c)  {
     defEditor = c;
   }

   public static LwComponent createDefEditor ()
   {
     LwTextField editor = new LwTextField ("");
     editor.getViewMan(true).setBorder((LwView)null);
     editor.setInsets (1,1,1,1);
     editor.setBackground (Color.white);     
     return editor;
   }
}
